The patternset storage component.

Carries all necessary data and methods for the patternset stuff.

author | Andreas Aderhold, andi@binarycloud.com
version | $Id: af3bd3709d79ad0299bf6ec0130a8a244ee325ab $
package | phing.types

### Methods

## Adds the patterns of the other instance to this set.

    append($other, $p)

### Parameters

#### $other

#### $p

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()

## Add a name entry on the exclude list

    createExclude() : \PatternSetNameEntry

### Exceptions

`\BuildException` |

### Returns

`\PatternSetNameEntry`Reference to object

## add a name entry on the exclude files list

    createExcludesFile() : \PatternSetNameEntry

### Exceptions

`\BuildException` |

### Returns

`\PatternSetNameEntry`Reference to object

## Add a name entry on the include list

    createInclude() : \PatternSetNameEntry

### Exceptions

`\BuildException` |

### Returns

`\PatternSetNameEntry`Reference to object

## Add a name entry on the include files list

    createIncludesFile() : \PatternSetNameEntry

### Exceptions

`\BuildException` |

### Returns

`\PatternSetNameEntry`Reference to object

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()

## Returns the filtered exclude patterns.

    getExcludePatterns(\Project $p)

### Parameters

#### $p

## Returns the filtered include patterns.

    getIncludePatterns(\Project $p)

### Parameters

#### $p

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()

### Returns

`\Project`Reference to current porject object

## Performs the check for circular references and returns the referenced PatternSet.

    getRef(\Project $p)

### Parameters

#### $p

## helper for FileSet.

    hasPatterns()

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()

### Parameters

#### $desc

## Sets the set of exclude patterns.

    setExcludes(string $excludes) : void

Patterns may be separated by a comma or a space.

### Parameters

#### $excludes

`string`

the string containing the exclude patterns

### Exceptions

`\BuildException` |

## Sets the name of the file containing the excludes patterns.

    setExcludesFile(\excludesFile $excludesFile)

### Parameters

#### $excludesFile

`\excludesFile`

The file to fetch the exclude patterns from.

## Sets the set of include patterns.

    setIncludes(string $includes) : void

Patterns may be separated by a comma or a space.

### Parameters

#### $includes

`string`

the string containing the include patterns

### Exceptions

`\BuildException` |

## Sets the name of the file containing the includes patterns.

    setIncludesFile(\includesFile $includesFile)

### Parameters

#### $includesFile

`\includesFile`

The file to fetch the include patterns from.

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Makes this instance in effect a reference to another PatternSet instance.

    setRefid(\Reference $r) : void

You must not set another attribute or nest elements inside this element if you make it a reference.

### Parameters

#### $r

`\Reference`

## toString()

    toString()

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()

## add a name entry to the given list

    addPatternToList(array $list) : \PatternSetNameEntry

### Parameters

#### $list

`array`

List onto which the nameentry should be added

### Returns

`\PatternSetNameEntry`Reference to the created PsetNameEntry instance

## Convert a array of PatternSetNameEntry elements into an array of Strings.

    makeArray($list, \Project $p)

### Parameters

#### $list

#### $p

## Read includesfile or excludesfile if not already done so.

    readFiles(\Project $p)

### Parameters

#### $p

## Reads path matching patterns from a file and adds them to the includes or excludes list

    readPatterns(\PhingFile $patternfile, $patternlist, \Project $p)

### Parameters

#### $patternfile

#### $patternlist

#### $p

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project

##

    $excludeList

##

    $excludesFileList

##

    $includeList

##

    $includesFileList